<template>
  <section class="container">
    <div class="page-content" @mousemove="mouseMove($event)">
      <button class="btn add-btn add-group-btn" @click="addGroup">
        Add Group
      </button>
      <task-group v-for="item in items" :key="item.id" :group="item" @move="move" @breakMove="breakMove"  ref="groupBoxInner"/>
    </div>
  </section>
</template>

<script>
import CreateGroupModal from '@/components/CreateGroupModal.vue';
import TaskGroup from '@/components/TaskGroup.vue';
import { mapGetters, mapMutations } from 'vuex';

export default {
  components: {
    CreateGroupModal,
    TaskGroup
  },

  async fetch({ store }) {
    await store.dispatch('tasks/getItems');
  },

  data() {
     return {
       clicked: false,
       title: '',
       current_group: ''
     };
   },

   computed: {
      ...mapGetters({
        items: 'tasks/items'
      }),
    },

    methods: {
      addGroup(){
        this.$modal.show(CreateGroupModal,{},{
          width: 320,
          height: 'auto'
        });
      },

      mouseMove(event){
        if(this.clicked){
          this.clicked.style.position = 'absolute';
          this.clicked.style.left = (event.clientX - 120) + 'px';
          this.clicked.style.top = (event.clientY - 30) + 'px';
        }
        return false
      },

      move(data) {
        this.clicked = data.event.currentTarget;
        this.current_group = data.event.currentTarget.parentElement;
        return false;
      },

      breakMove(data){
        if(!this.clicked){
          return false;
        }
        let targetTask = this.clicked
        let targetLeft = targetTask.getBoundingClientRect().left;
        let minimum = 10000;
        let group = '';
        let new_group_id = 0;
        this.$refs.groupBoxInner.filter(function (number,index) {
          let groupBoxLeft = number.$el.getBoundingClientRect().left;
          if(Math.abs(groupBoxLeft - targetLeft) < minimum){
            minimum = Math.abs(groupBoxLeft - targetLeft);
            group = number.$el.querySelector('.task-container');
            new_group_id = number.$vnode.key;
          };
        });
        if(this.current_group !== group){
          this.changeTaskGroup(data.task_id, new_group_id);
        };
        this.clicked.style.position = 'static';
        this.clicked = false;
        return false;
      },

      ...mapMutations({setGroup: "tasks/SET_GROUP"}),

      changeTaskGroup(task_id, group_id){
        this.setGroup({
          group_id: group_id,
          task_id: task_id
        });
      }

    }
}
</script>
